package org.wso2.carbon.user.core.hybrid.actdir;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.naming.ldap.InitialLdapContext;
import javax.naming.ldap.LdapContext;

public class ActDirRealmConfig {

    private String connectionURL = null;

    private String connectionName = null;

    private String connectionPassword = null;

    private String searchBase = null;

    private String driverName = "com.sun.jndi.ldap.LdapCtxFactory";

    public ActDirRealmConfig() {

    }

    public String getDriverName() {
	return driverName;
    }

    public String getConnectionName() {
	return connectionName;
    }

    public String getSearchBase() {
	return searchBase;
    }

    public void setSearchBase(String searchBase) {
	this.searchBase = searchBase;
    }

    public String getConnectionURL() {
	return connectionURL;
    }

    public void setConnectionURL(String connectionURL) {
	this.connectionURL = connectionURL;
    }

    public void setConnectionName(String connectionName) {
	this.connectionName = connectionName.trim();
    }

    public String getConnectionPassword() {
	return connectionPassword;
    }

    public void setConnectionPassword(String connectionPassword) {
	this.connectionPassword = connectionPassword;
    }

    public LdapContext getContext() throws NamingException {

	LdapContext context = null;

	try {
	    context = new InitialLdapContext(getDirectoryContextEnvironment(), null);
	} catch (NamingException e) {
	    e.printStackTrace();
	    context = null;
	    try {
		context = new InitialLdapContext(getDirectoryContextEnvironment(), null);
	    } catch (NamingException e1) {
		context = null;
		throw new NamingException();
	    }
	} finally {

	}
	return (context);

    }

    protected Hashtable getDirectoryContextEnvironment() {

	Hashtable env = new Hashtable();

	env.put(Context.INITIAL_CONTEXT_FACTORY, driverName);

	if (connectionName != null)
	    env.put(Context.SECURITY_PRINCIPAL, connectionName);

	if (connectionPassword != null)
	    env.put(Context.SECURITY_CREDENTIALS, connectionPassword);

	if (connectionURL != null)
	    env.put(Context.PROVIDER_URL, connectionURL);

	env.put(Context.SECURITY_AUTHENTICATION, "simple");

	return env;

    }

}
